﻿# -*- coding: utf-8 -*-

import wx
import gui
import os
import ui
import controlTypes
import globalPluginHandler
import api
import winsound
import config
import io
import subprocess


class GlobalPlugin(globalPluginHandler.GlobalPlugin):

	def __init__(self):
		super(globalPluginHandler.GlobalPlugin, self).__init__()
		self.prefsMenu = gui.mainFrame.sysTrayIcon.menu.GetMenuItems()[0].GetSubMenu()
		self.NTMitem = self.prefsMenu.Append(wx.ID_ANY, _("Manage &Theemes settings..."), _("Manage theems"))
		gui.mainFrame.sysTrayIcon.Bind(wx.EVT_MENU, self.onNTM, self.NTMitem)

	def terminate(self):
		try:
			self.prefsMenu.RemoveItem(self.NTMitem)
		except wx.PyDeadObjectError:
			pass

	def onNTM(self, event):
		Path = os.path.dirname(__file__)
		NTMPath = os.path.join(Path, "bin")
		ExePath = os.path.join(NTMPath, "NTM For NVDA.exe")
		if os.path.isfile(ExePath):
			try:
				subprocess.Popen(ExePath)
			except:
				pass


	def event_gainFocus(self, obj, nextHandler):
		t = ''
		perent = obj.parent
		path = config.getUserDefaultConfigPath()
		ntmFile = path  + "\\" + "theem.ntm"
		if os.path.isfile(ntmFile):
			f = open(ntmFile, 'r')
			t = f.read()
			f.close()
		else:
			t = 'c:\\snd\\'
		sub = 'silence.wav'
		if obj.role==controlTypes.ROLE_BUTTON:
			sub = 'button.wav'
		if obj.role==controlTypes.ROLE_MENUITEM:
			if obj== perent.firstChild:
				sub = 'first.wav'
			if obj== perent.lastChild:
				sub = 'last.wav'
			else:
				sub = 'menu_item.wav'
		if obj.role==controlTypes.ROLE_SPLITBUTTON:
			sub = 'splitbutton.wav'
		if obj.role==controlTypes.ROLE_CHECKBOX:
			sub = 'checkbox.wav'
		if obj.role==controlTypes.ROLE_COMBOBOX:
			sub = 'combobox.wav'
		if obj.role==controlTypes.ROLE_CLOCK:
			sub = 'clock.wav'
		if obj.role==controlTypes.ROLE_MENUBUTTON:
			sub = 'button.wav'
		if obj.role==controlTypes.ROLE_LISTITEM:
			if obj== perent.firstChild:
				sub = 'first.wav'
			if obj== perent.lastChild:
				sub = 'last.wav'
			else:
				sub = 'listitem.wav'
		if obj.role==controlTypes.ROLE_RADIOBUTTON:
			sub = 'radiobutton.wav'
		if obj.role==controlTypes.ROLE_TREEVIEWITEM:
			sub='treeviewitem.wav'
		if obj.role==controlTypes.ROLE_EDITABLETEXT:
			sub = 'edit_text.wav'
		if obj.role==controlTypes.ROLE_DATAITEM:
			sub = 'menu_item.wav'
		if obj.role==controlTypes.ROLE_TAB:
			sub = 'tab.wav'
		if obj.role==controlTypes.ROLE_LINK:
			sub = 'link.wav'
		if controlTypes.STATE_PROTECTED in obj.states or obj.role==controlTypes.ROLE_PASSWORDEDIT:
			sub = 'protected.wav'
		if obj.role==controlTypes.ROLE_CHECKBOX and controlTypes.STATE_CHECKED in obj.states:
			sub = 'checkbox_checked.wav'
		if obj.role==controlTypes.ROLE_RADIOBUTTON and controlTypes.STATE_CHECKED in obj.states:
			sub = 'checkbox_checked.wav'

		path = t + sub
		if os.path.isfile(path):
			try:
				winsound.PlaySound(path, winsound.SND_ASYNC)
			except:
				pass
		else:
			pass
		nextHandler()
		pass

	def script_runApp(self, gesture):
		Path = os.path.dirname(__file__)
		NTMPath = os.path.join(Path, "bin")
		ExePath = os.path.join(NTMPath, "NTM For NVDA.exe")
		if os.path.isfile(ExePath):
			try:
				subprocess.Popen(ExePath)
			except:
				pass


	def script_loop(self, gesture):
		path = config.getUserDefaultConfigPath()
		ntmFile = path  + "\\" + "theem.ntm"
		f = open(ntmFile, 'r')
		l = f.read()
		f.close()
		p = l+"loop.wav"
		try:
			winsound.PlaySound(p, winsound.SND_ASYNC)
		except:
			pass
	script_runApp.__doc__ = _("Opens the NVDA Theems Manager window to manage NVDA theems settings.")
	script_loop.__doc__ = _("Plays a loop music for currently active theem.")
	__gestures={
		"kb:NVDA+control+l": "loop",
		"kb:NVDA+shift+m": "runApp",
	}
 
	def event_caret(self, obj, nextHandler):
		sub = ""
		if obj.role==controlTypes.ROLE_EDITABLETEXT:
			sub = 'caret.wav'
		else:
			sub = 'silence.wav'
		path = config.getUserDefaultConfigPath()
		ntmFile = path  + "\\" + "theem.ntm"
		f = open(ntmFile, 'r')
		t = f.read()
		f.close()
		path = t + sub
		if os.path.isfile(path):
			try:
				winsound.PlaySound(path, winsound.SND_ASYNC)
			except:
				pass

		nextHandler()
		pass
